<%option explicit%>
<%response.buffer=true%>
<!--#include file="admin$db.asp"-->
<%ShopOpenDatabase dbc%>
<!--#include file="help/shoph_editrecord.asp"-->
<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Edits translate table - product
'*********************************************************************************

ShopCheckAdmin ""
dim Addaction, Updateaction, Deleteaction
dim rstemp
dim which
dim IDField
dim DBTable
dim translatetable
dim languages, langcount, url
dim strlanguage, CatalogId
'dim helpfile

'700 - Meta Tags
dim productmetatitle
dim productmetakeyword
dim productmetadescription

'helpfile = "shoph_producthelp.htm"

SetSess "currenturl", "shopa_edittranslateproducts.asp"
Addaction = Request.form("add")
Updateaction = Request.form("update")
SError = ""
Deleteaction = request("delete")
GetInputValues
if DeleteAction<>"" then
   '700 - 2010.04.22 - cross site script security enhancement
   verifygenpredefinedsecuritycode request("genpredefinedsecuritycode")

   DeleteRecord
end if

if Addaction = "" and Updateaction = "" then
   AdminPageHeader
   SetDefaultvalues
   GenerateForm
   AdminPageTrailer
else
   '700 - 2010.04.22 - cross site script security enhancement
   verifygenpredefinedsecuritycode request("genpredefinedsecuritycode")

   AdminPageHeader
   'SetDefaultvalues
   validatefields
   if SError = "" then
      UpdateRecord
   end if
   GenerateForm
   AdminPageTrailer
end if
ShopCloseDatabase dbc

'************************

sub GetInputValues
   dim force
   ' ID, allows editing a record
   which = request.querystring("which")

   '6.09 - Precautionary Security Fix
   if which > "" then
      if not isnumeric(which) then
         ShopError "ID must be numeric"
      end if
   end if

   IDField = request.querystring("IDField")
   if IDField = "" then
      IDField = "translateid"
   end if
   DBTable = request.querystring("table")
   CatalogId = request.querystring("CatalogId")

   '6.09 - Precautionary Security Fix
   if CatalogId > "" then
      if not isnumeric(CatalogId) then
         ShopError "Catalog ID must be numeric"
      end if
   end if

   url = request("url")
   if url = "" then
      url = GetSess("currenturl")
   end if

   strlanguage = request.form("lang")
   if trim(CatalogId) = "" then CatalogId = request.form("CatalogId")
   strCname = request.form("cname")
   memcdescription = request.form("cdescription")
   memexdesc = request.form("extendeddesc")
   productmetatitle = request.form("productmetatitle")
   productmetakeyword = request.form("productmetakeyword")
   productmetadescription = request.form("productmetadescription")

   ValidateTable
   force = "Yes"
   GetLanguages languages, langcount, force
end sub

sub ValidateTable
   'See if user has access to this table
   dim UserTables, i, tablecount

   if GetConfig("XRestrictAdminTables")<>"Yes" then exit sub
   UserTables = GetSess("UserTables")

   if isnull(UserTables) then
      exit sub
   end if

   if UserTables = "" then
      exit sub
   else
      UserTables = split(GetSess("UserTables"), ",", -1, 1)
   end if

   tablecount = ubound(UserTables)

   for i = 0 to tablecount
      if ucase(DBTable) = ucase(Usertables(i)) then
         exit sub
      end if
   next

   DBTable = ""
   ShopError GetLang("langEditSelectFail")
end sub

' Get the specific record and then generate form based on this record
sub GenerateForm
   dim sqltemp

   if which <> "" then
      sqltemp = "select * from " & DBTable
      sqltemp = sqltemp & " where " & IDField & "=" & which
      Set rstemp = Server.CreateObject("ADODB.Recordset")

      '701 - 2011.12.07 - Enhancement: Speed up admin pages
      rstemp.open sqltemp, dbc, adOpenStatic, adLockReadOnly
   end if
   DisplayForm
   if which <> "" then
      rstemp.close
      set rstemp = nothing
   end if
end sub

sub DisplayForm()
   if which <> "" then
      memcdescription = rstemp("cdescription")
      strlanguage = rstemp("lang")
      if rstemp("CatalogId") <> request.querystring("CatalogId") then
         CatalogId = rstemp("CatalogId")
      else
         CatalogId = request.querystring("CatalogId")
      end if

      '701 - 2011.12.05 - Enhancement: Check if the non-admin user have the right to update translate record
      dim rcmain
      CheckForUserID catalogid,rcmain
      if rcmain<>0 then
	     closerecordset rstemp
	     shoperror GetLang("langeditselectfail")
      end if

      strcname = rstemp("cname")
      memexdesc = rstemp("extendeddesc")
      productmetatitle = rstemp("productmetatitle")
      productmetakeyword = rstemp("productmetakeyword")
      productmetadescription = rstemp("productmetadescription")
   end if
%>
<form name="editform" action="<%=GetSess("currenturl")%>?which=<%=which%>&IDField=<%=IDField%>&table=<%=DBTable%>&CatalogId=<%=CatalogId%>" method="POST">
<%
'700 - 2010.04.22 - cross site script security enhancement
htmlwrite "<input type=""hidden"" name=""genpredefinedsecuritycode"" value="""& session("genpredefinedsecuritycode") &""" />"
%>
  <%'600 - ADD HTML EDITOR
   AddEditor "editform"
%>
  <table width='100%' cellpadding="0" cellspacing="0">
    <tr>
      <td align='left'><%ShopWriteHeader "Product Information"%></td>
      
    <%'701 - 2011.07.14 - Bug Fix: Translate page advanced edit issues%>
    <td valign='top' align="right"><table>
        <tr>
          <%
   if which<>"" then
      htmlwrite "<td align='center'><a href='shopa_editrecord.asp?which=" & which & "&table=" & DBTable & "&IDField=" & IDField &"'><img src='images/admin/main/edit-24.gif' border=0></a></td>"
   end if
   htmlwrite "<td align='center'><a href='shopa_editdisplay.asp?page="& GetSess("pagenumberaddproduct") &"&which=" & which & "&table=" & DBTable &"'><img src='images/admin/main/arrow_left_blue.gif' border=0></a></td></tr><tr>"
   if which <> "" then
      htmlwrite "<td><a href='shopa_editrecord.asp?which=" & which & "&table=" & DBTable & "&IDField=" & IDField &"'>" & GetLang("langadminadvanced") & " " & GetLang("LangCommonEdit") & "</a></td>"
   end if
   htmlwrite "<td><a href='shopa_editdisplay.asp?page="& GetSess("pagenumberaddproduct") &"&which=" & which & "&table=" & DBTable &"'>Back To " & ucase(left(DBTable, 1)) & right(DBTable, len(DBTable) - 1) & "</a></td>"
%>
        </tr>
      </table></td>

    </tr>
    <tr>
      <td colspan='2' align='center'><%ShopWriteError SError%></td>
    </tr>
  </table>
  <%
   GenerateDisplayHeader "Product Translation"
   GenerateDisplayBodyHeader

   '6.50 - added buttons to top of page as well
   htmlwrite "<div align='center'>"
   if which<>"" then
      '700 - 2010.05.17 - Bug Fix: Unable to uprdate product/content/etc when using chrome or safari.
      htmlwrite "&nbsp;&nbsp;<input class=""submitbtn"" type=submit name=Update value='" & GetLang("LangEditUpdateRecord") & "'>&nbsp;&nbsp;"
      htmlwrite "<input class=""submitbtn"" type=submit name=add value='" & GetLang("LangEditCopy") & "'>"
	  '700 - 2010.06.18 - Enhancement: Delete record notification
      htmlwrite "&nbsp;&nbsp;<input class=""submitbtn"" onclick='return doDeleteWarning()' type=submit name=Delete value='" & GetLang("LangCommonDelete") & "'>"
      htmlwrite "</p>"
   else
      '700 - 2010.05.17 - Bug Fix: Unable to uprdate product/content/etc when using chrome or safari.
      htmlwrite "<input class=""submitbtn"" type=submit name=add value='" & GetLang("LangEditAdd") & "'>"
   end if
   htmlwrite "</div><br />"
   htmlwrite TableDef
   htmlwrite tablerow & tablecolumn & GetLang("LangLanguage") & tablecolumnend & tablecolumn
   GenerateSelectNV languages, strlanguage, "lang", langcount, GetLang("Langcommonselect")
   GenHelpIcon("document.all.help_translateproducts_language")
   htmlwrite Tablecolumnend & TableRowEnd

   '701 - 2011.12.05 - Enhancement: Disable to edit parentid for translate record if non-admin user
   if GetSess("admintype") <> "SUPER" then
      FormatEditRowStatic GetLang("langCatalogId"), "CatalogId", CatalogId, "document.all.help_translateproducts_catalogid"
	  htmlwrite "<input type=""hidden"" name=""CatalogId"" id=""CatalogId"" value="""& CatalogId &""" />"
   else
      formateditrow "CatalogId", "CatalogId", CatalogId, "document.all.help_translateproducts_catalogid"
   end if

   '7.01 - 2010.10.12 - Bug Fix: Edit translate page should use text box
   formateditrow GetLang("LangProductName"), "cname" , strCname, "document.all.help_translateproducts_name"
   
   PCreateRowText GetLang("LangProductDescription"), "cdescription", memcdescription, 3, "cdescription", "document.all.help_translateproducts_desc"
   PCreateRowText GetLang("LangProductEXtendedDescription"), "extendeddesc", memexdesc, 3, "extendeddesc", "document.all.help_translateproducts_more"

   formateditrow GetLang("langcommonmetatitle"), "productmetatitle" , productmetatitle, "document.all.help_translateproducts_metatitle"
   PCreateRowMemo GetLang("langcommonmetakeywords"), "productmetakeyword", productmetakeyword, 8, "document.all.help_translateproducts_metakeywords"
   PCreateRowMemo GetLang("langcommonmetadescription"), "productmetadescription", productmetadescription, 8, "document.all.help_translateproducts_metadescription"
   
   htmlwrite TableDefEnd
   htmlwrite "<center>"
   if which<>"" then
      '700 - 2010.05.17 - Bug Fix: Unable to uprdate product/content/etc when using chrome or safari.
      htmlwrite "&nbsp;&nbsp;<input class=""submitbtn"" type=submit name=Update value='" & GetLang("LangEditUpdateRecord") & "'>&nbsp;&nbsp;"
      htmlwrite "<input class=""submitbtn"" type=submit name=add value='" & GetLang("LangEditCopy") & "'>"

      '6.50 - moved delete button to same line as add and update
	  '700 - 2010.06.18 - Enhancement: Delete record notification
      htmlwrite "<br /><br /><input class=""submitbtn"" onclick='return doDeleteWarning()' type=submit name=Delete value='" & GetLang("LangCommonDelete") & "'>"
      htmlwrite "</p>"
   else
      '700 - 2010.05.17 - Bug Fix: Unable to uprdate product/content/etc when using chrome or safari.
      htmlwrite "<input class=""submitbtn"" type=submit name=add value='" & GetLang("LangEditAdd") & "'>"
   end if
%>
  </center>
</form>
<%
   GenerateDisplayBodyFooter
   gethelp "translateproducts"
end sub

sub UpdateRecord
   dim sqltemp, rc
   
   '701 - 2011.12.05 - Enhancement: Check if the non-admin user have the right to update translate record
   CheckForUserID catalogid,rc
   if rc<>0 then exit sub

   '6.50 - broadened defintion of IF statement to cover cases where xmysql hasn't been set
   if instr(ucase(xdatabasetype), "MYSQL") > 0 then
      MYSQLProcessrecord updateaction, dbc, DBTable, IDField, which
      exit sub
   end if

   if updateaction<>"" then
      '701 - 2011.12.05 - Bug Fix: SQL DB: Not able to insert value to new translate record.
      'sqltemp = "select * from " & DBTable
      'sqltemp = sqltemp & " where " & IDField & "=" & which
      'set rstemp = Server.createobject("ADODB.Recordset")
      'rstemp.open sqltemp, dbc, 1, 3
      'rstemp.Update
   else
      CheckForDuplicate rc
      if rc<>0 then exit sub
      set rstemp = Server.createobject("ADODB.Recordset")
      rstemp.open DBTable, dbc, adOpenKeyset, adLockOptimistic
      rstemp.AddNew

      '701 - 2011.12.05 - Bug Fix: SQL DB: Not able to insert value to new translate record.
	  rstemp.update
	  which = rstemp(IDField)
	  rstemp.close
	  set rstemp = nothing
   end if

   '701 - 2011.12.05 - Bug Fix: SQL DB: Not able to insert value to new translate record.
   sqltemp = "select * from " & DBTable
   sqltemp = sqltemp & " where " & IDField & "=" & which
   set rstemp = Server.createobject("ADODB.Recordset")
   rstemp.open sqltemp, dbc, adOpenKeyset, adLockOptimistic
   rstemp.Update

   GenerateUpdateSQL
   which = rstemp(IDField)
   rstemp.close
   set rstemp = nothing
   SError = SError & "<br /><b>" & GetLang("LangEdit03") & "</b>"
end sub

sub GenerateUpdateSQL()
   dim howmanyfields, fieldname, fieldvalue, fieldtype, i
   howmanyfields = rstemp.fields.count -1
   rstemp.update

   for i = 1 to howmanyfields
      fieldname = rstemp(i).name
      fieldtype = rstemp(i).type
      fieldvalue = request.form(fieldname)
      EUpdateField fieldname, fieldvalue
   next
   rstemp.update
end sub

sub EUpdateField (fieldname, fieldvalue)
   on error resume next
   if fieldvalue = "" then
      rstemp(Fieldname) = NULL
      exit sub
   end if

   if ucase(fieldvalue) = "NULL" then
      rstemp(Fieldname) = NULL
   else
      rstemp(Fieldname) = fieldvalue
   end if
end sub

' Set default values from parent record
sub SetDefaultvalues
   dim sql, rs
   if which<>"" then exit sub
   if CatalogId = "" then exit sub

   sql = "select * from products where CatalogId=" & CatalogId
   Set rs = Server.CreateObject("ADODB.Recordset")

   '701 - 2011.12.07 - Enhancement: Speed up admin pages
   rs.open sql, dbc, adOpenStatic, adLockReadOnly

   if not rs.eof then
      memcdescription = rs("cdescription")
      memexdesc = rs("extendeddesc")
      strcname = rs("cname")
	  productmetatitle = rs("productmetatitle")
	  productmetakeyword = rs("productmetakeyword")
	  productmetadescription = rs("productmetadescription")
   end if

   CloseRecordSet rs
end sub

sub DeleteRecord
   dim sql, url
   sql = "delete from " & DBTable & " where " & IDField & "=" & which
   dbc.execute(sql)
   url = "shopa_editdisplay.asp?table=" & DBTable
   ResponseRedirect url
end sub

' New to find which table and which record
sub GetFormFields
end sub

sub GetExistingProduct
   dim rs, sql
   sql = "Select " & realname & " from " & table & " where " & IDField & "=" & recordid
   response.flush
   Set rs = Server.CreateObject("ADODB.Recordset")

   '701 - 2011.12.07 - Enhancement: Speed up admin pages
   rs.open sql, dbc, adOpenStatic, adLockReadOnly

   if not rs.eof then
      textdata = rs(realname)
   end if
   CloseRecordSet rs
end sub

sub PCreateRowText (caption, fieldname, fieldvalue, rows, realname, passhelpstring)
   dim url, htmlurl, linkurl
   url = "shopa_edittranslate.asp?which=" & which
   htmlurl = "shopa_htmledit.asp?which=" & which & "&IDField=CatalogId&table=products&fieldname=" & realname
   htmlurl = htmlurl & "&url=" & server.urlencode(url)
   Linkurl = "<a href='" & htmlurl & "'>" & "HTML edit" & "</a>"
   response.write tablerow & tablecolumn & caption
   response.write tablecolumnend
   response.write "<td>"'<Textarea rows=" & rows & " cols=40  name='" & fieldname & "'>" & fieldvalue & "</textarea>"
      response.write "<Textarea rows=" & rows & " cols=40  name='" & fieldname & "'>" & fieldvalue & "</textarea>"
   GenHelpIcon(passhelpstring)
   response.write "</td>"
   response.write "</tr>"
end sub

' Get languages from language file or array
' Do not include default laqnguage
sub GetLanguages (languages, langcount, force)
   dim cid, name, catSQL, i, defaultlang
   dim maxlangs, catrs, mylink

   langcount = 0
   maxlangs = 20
   defaultlang = lcase(GetConfig("xlanguage"))
   redim languages(maxlangs)

   catSQL = "SELECT lang from languages GROUP BY lang"
   Set catrs = Server.CreateObject("ADODB.Recordset")

   '701 - 2011.12.07 - Enhancement: Speed up admin pages
   catrs.open catsql, dbc, adOpenStatic, adLockReadOnly

   do while not catrs.eof and langcount<maxlangs
      name = catrs("lang")
      if lcase(name)<>defaultlang then
         languages(langcount) = name
         langcount = langcount + 1
      end if
      catrs.MoveNext
   loop
   CloseRecordSet catrs
end sub

' check CatalogId and language match on adding a record
sub CheckForDuplicate (rc)
   dim CatalogId, strlanguage, rs
   rc = 0
   CatalogId = request("CatalogId")
   strlanguage = request("lang")

   '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
   sql = "select * from " & DBTable & " where lang="& sqlserverprefixn &"'"& strlanguage & "'"
   sql = sql & " and CatalogId=" & CatalogId
   Set rs = Server.CreateObject("ADODB.Recordset")

   '701 - 2011.12.07 - Enhancement: Speed up admin pages
   rs.open sql, dbc, adOpenStatic, adLockReadOnly

   if not rs.eof then
      SError = SError & "<br />" & GetLang("langrecordexists")
      rc = 4
   end if
   CloseRecordSet rs
end sub

' need language and categoryid
sub Validatefields
   dim strlanguage, rs, categoryid

   CatalogId = request("CatalogId")
   strlanguage = request("lang")

   if strlanguage = GetLang("langcommonselect") then
      strlanguage = ""
   end if

   if strlanguage = "" then
      SError = SError & "<br />" & GetLang("LangLanguage") & " " & GetLang("langcustrequired")
   end if

   if CatalogId = "" then
      SError = SError & "<br />" & "CatalogId " & GetLang("langcustrequired")
   end if
end sub

sub PCreateRowMemo (caption, fieldname, fieldvalue, rows, passhelpstring)
   HtmlWrite tablerow & "<td align='200' valign='top'>" & caption
   HtmlWrite tablecolumnend & "<td align='left'>"
   HtmlWrite "<Textarea rows=" & rows & " cols=50  name='" & fieldname & "'>" & fieldvalue & "</textarea>"
   GenHelpIcon(passhelpstring)
   HtmlWrite "</td>"
   HtmlWrite "</tr>"
end sub

'701 - 2011.12.05 - Enhancement: Check if the non-admin user have the right to update translate record
sub CheckForUserID (catalogid, rc)
   if getconfig("xadminrestrictproducts") <> "Yes" then exit sub
   if trim(catalogid) = "" then exit sub
   if ucase(GetSess("admintype")) = "SUPER" then exit sub

   dim sql,strproductuserid,rs
   rc = 0
   strproductuserid = ""
   sql = "select userid from products where catalogid = "& catalogid &""
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open sql, dbc, adOpenStatic, adLockReadOnly
   if not rs.eof then
      strproductuserid = rs("userid")
   end if
   CloseRecordSet rs

   if ucase(strproductuserid) <> ucase(GetSess("shopadmin")) then
      SError = SError & "<br />" & GetLang("langeditselectfail")
      rc = 4
   end if
end sub
%>