<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Used only if VP-ASP Option Package is not installed
' Option package uses Templates
'*********************************************************************************

sub FormatMail (rsOrder, rsitems, merchant, customer)
   dim ydecimalpoint
   ydecimalpoint = GetConfig("xdecimalpoint")
   Body = ""
   dim Body
   dim body1
   dim body2
   dim CR
   dim description
   dim FullName, AddressName, CityName, StateName, CountryName, PostalName, Nameb, Addressb, Cityb, Stateb, Countryb, Companyb, Postalb
   dim Companyname
   dim DeliveryAddress, DeliveryArray
   dim downloadlink
   CR = GetMailCR
   SetSess ("EmailFormat"), "Text"
   body1 = GetLang("langmailmerchant") & cr
   body2 = GetLang("langmailcustomer") & cr
   body = GetLang("langmailordernumber") & rsorder("orderid") & cr &_
   GetLang("langmailorderamount") & ShopFormatCurrency(rsorder("orderamount"), ydecimalpoint) & cr &_
   GetLang("langmailshippingcost") & ShopFormatCurrency(rsorder("oshipcost"), ydecimalpoint) & cr &_
   GetLang("langmailshippingmethod") & rsorder("oshipmethodtype") & cr &_
   GetLang("langmailtax") & ShopFormatCurrency(rsorder("otax"), ydecimalpoint) & cr
   '6.50 - add handling for Canadian PST
   if not isnull(rsorder("opst")) then
      body = body & "PST" & ShopFormatCurrency(rsorder("opst"), ydecimalpoint) & cr
   end if
   '6.50 - show handling fee
   GetLang("langproducthandling") & ShopFormatCurrency(rsorder("ohandling"), ydecimalpoint) & cr

   if rsorder("odiscount")>0 then
      body = body & GetLang("langmaildiscount") & ShopFormatCurrency(rsorder("odiscount"), ydecimalpoint) & cr
   end if
   body = body & cr &_
   GetLang("langmailpayment") & rsorder("ocardtype") & cr &_
   GetLang("langmaildate") & shopdateformat(rsorder("odate"), GetConfig("xdateformat")) & cr &_
   GetLang("langmailphone") & rsorder("ophone") & cr &_
   GetLang("langmailemail") & rsorder("oemail") & cr & cr &_
   GetLang("langmailshipto") & cr & cr
   if not isnull(rsorder("oshipname")) then
      fullname = rsorder("oshipname")
   else
      fullname = rsorder("ofirstname") & " " & rsorder("olastname")
   end if
   if not isnull(rsorder("oshipaddress")) then
      addressname = rsorder("oshipaddress")
   else
      addressname = rsorder("oaddress")
   end if
   if not isnull(rsorder("oshiptown")) then
      CityName = rsOrder("oshiptown")
   else
      CityName = rsOrder("ocity")
   end if
   if not isnull(rsorder("oshipstate")) then
      StateName = rsOrder("oshipstate")
   else
      StateName = rsOrder("ostate")
   end if
   if not isnull(rsorder("oshipzip")) then
      PostalName = rsOrder("oshipzip")
   else
      PostalName = rsOrder("opostcode")
   end if
   if not isnull(rsorder("oshipcountry")) then
      CountryName = rsOrder("oshipcountry")
   else
      CountryName = rsOrder("ocountry")
   end if
   Body = Body & FullName & CR
   if not isnull(rsorder("oshipcompany")) then
      Body = Body & rsOrder("oshipcompany") & CR
   else
      if not isnull(rsorder("ocompany")) then
         Body = Body & rsOrder("ocompany") & CR
      end if
   end if
   Body = Body & AddressName & CR &_
   "" & CityName & ", " & StateName & " " & PostalName & CR &_
   "" & CountryName & CR & CR &_
   GetLang("langMailCustomerIs") & CR & CR
   FullName = rsOrder("ofirstname") & " " & rsOrder("olastname")
   AddressName = rsOrder("oaddress")
   CityName = rsOrder("ocity")
   StateName = rsOrder("ostate")
   PostalName = rsOrder("opostcode")
   CountryName = rsOrder("ocountry")
   Companyname = ""
   if not isnull(rsorder("ocompany")) then
      Companyname = ("ocompany")
   end if
   Body = Body & FullName & CR
   Body = Body & AddressName & CR &_
   "" & CityName & ", " & StateName & " " & PostalName & CR &_
   "" & CountryName & CR & CR &_
   GetLang("langMailProducts") & CR & CR
   do while not RSItems.eof
      Itemname = RSItems("itemname")
      if GetConfig("XdeliveryAddress") = "Yes" then
         Deliveryaddress = RSITEMS("address")
         if not isnull(Deliveryaddress) and Deliveryaddress<>"" then
            ConvertDeliveryToArray DeliveryArray, Deliveryaddress
            GetDeliveryName Itemname, DeliveryArray
         end if
      end if
      Itemname = RemoveHtmlmail(itemname, CR)
      Body = Body & "" & itemname & CR
      Body = Body & GetLang("langProductQuantity") & ": " & RSItems("numitems") & CR
      Body = Body & GetLang("langProductPrice") & ": " & ShopFormatCurrency(RSItems("unitprice"), ydecimalpoint) & CR & CR
      ' add download emails
      if GetConfig("xendoforderhyperlinkemail") = "Yes" then
         downloadlink = GetEmaildownloadLink(RSItems("CatalogId"))
         if downloadlink <> "" then
            Body = Body & GetLang("LangorderDownload") & ": " & downloadLink & CR
         end if
      end if
      RSItems.MoveNext
   loop

   if not isnull(rsorder("ocomment")) then
      Body = Body & GetLang("langOrderComments") & CR
      Body = Body & rsorder("ocomment")
   end if
   Merchant = Body1&Body
   Customer = Body2&CR&Body
end sub

function RemoveHtmlmail(itemname, CR)
   dim workrecord, firstchar, morefields, pos, endpos, length
   dim token
   workrecord = replace(itemname, "<br />", CR)

   'VP-ASP 6.50.4 Bugs Fix - 08 October 2008
   workrecord = replace(workrecord, "<br>", CR)
   workrecord = replace(workrecord, "<br/>", CR)
   workrecord = replace(workrecord, "<BR />", CR)
   workrecord = replace(workrecord, "<BR>", CR)
   workrecord = replace(workrecord, "<BR/>", CR)

   if GetConfig("xemailRemoveHtml")<>"Yes" then
      RemoveHtmlmail = workrecord
      exit function
   end if
   pos = 1
   morefields = True
   do while morefields = True
      pos = 1
      pos = instr(pos, workrecord, "<")
      if pos > 0 then
         endpos = instr(pos, workrecord, ">")
         if endpos = 0 then
            morefields = false
         else
            length = endpos - pos + 1
            token = mid(workrecord, pos, length)
            workrecord = replace(workrecord, token, "")
         end if
      else
         morefields = false
      end if
   loop
   RemoveHtmlmail = workrecord
end function
%>