<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' customer form page design routines
'*********************************************************************************

'For each customer other field set session values c_fieldname=value
sub CustomerGetFields
   dim words,wordcount,customervalues,i, cfieldname, fieldvalue
   dim required, requiredcount, testfield, j

   '6.50.4 Bugs Fix - 08 October 2008
   dim requiredCaption, customerFields,x

   if GetConfig("xCustomerOtherFields")="" then exit sub
   redim words(GetConfig("xCustomerMaxotherfields"))
   redim Required(GetConfig("xCustomerMaxotherfields"))
   ParseRecord GetConfig("xcustomerOtherFields"), words, wordcount,","
   if GetConfig("xCustomerOtherrequired")<>"" then
      ParseRecord GetConfig("xcustomerOtherRequired"), required, requiredcount,","
   else
      requiredcount=0
   end if

   for i = 0 to wordcount-1
      cfieldname="c_" & words(i)
	
      'Security Patch - 17 April 2008
      fieldvalue=CleanChars(request(words(i)))

      if fieldvalue=GetLang("langcommonselect") then
         fieldvalue=""
      end if
      SetSess cfieldname, fieldvalue
   next
   SetSess "customerFieldcount",wordcount
   if requiredcount=0 then exit sub
   for i = 0 to requiredcount-1
      testfield=required(i)
      cfieldname="c_" & testfield
      if GetSess(cfieldname)="" then
         '6.50.4 Bugs Fix - 08 October 2008
         customerFields = split(GetConfig("xcustomerotherfields"),",")
         for x = 0 to ubound(customerFields) - 1 
            if customerFields(x) = required(i) then exit for 
         next 
         requiredCaption = split(GetConfig("xcustomerothercaptions"),",")
         SError = SError & requiredCaption(x) & " " & GetLang("langCustRequired") & "<br>"
      end if
   next
end sub

sub ValidateCustomerFields
   if strfirstname = "" then
      SError = SError & GetLang("langCustFirstname")  & GetLang("langCustRequired") & "<br />"
   end if
   if strlastname = "" then
      SError = SError & GetLang("langCustLastname") &  GetLang("langCustRequired") & "<br />"
   end if
   if straddress = "" then
      SError = SError & GetLang("langCustAddress") & GetLang("langCustRequired") & "<br />"
   end if
   if strcity = "" then
      SError = SError & GetLang("langCustCity") & GetLang("langCustRequired") & "<br />"
   end if
   if GetConfig("xIncludeStates")="Yes"  and strstate="??" then
      strstate=""
   end if
   if GetConfig("xstaterequired")="Yes" then
      if GetConfig("xPromptForState")="Yes" then
	     if strstate = ""  then
		    SError = SError & GetLang("langCustState")  & GetLang("langCustRequired") & "<br />"
     	 end if
      end if
   end if
   if strpostcode = "" then
      SError = SError & GetLang("langCustPostCode") & GetLang("langCustRequired") & "<br />"
   end if
   if strPhone = "" then
      SError = SError & GetLang("langCustPhone") & GetLang("langCustRequired") & "<br />"
   end if
   if strEmail = "" then
      SError = SError & GetLang("langCustEmail") & GetLang("langCustRequired") & "<br />"
   else
      CustomerValidateEmail stremail
   end if

   '6.08a - Company required wasn't being accounted for
   if GetConfig("xcompanyrequired") = "Yes" and strcompany="" then
      SError = SError & GetLang("langcustcompany") & GetLang("langCustRequired") & "<br />"
   end if

   if GetConfig("xCountryRequired")="Yes" then
      if strcountry=""  or strcountry="??" then
	     SError = SError & GetLang("langCustCountry") & GetLang("langCustRequired") & "<br />"
      end if
   end if
   if GetConfig("xvatnumber")="Yes"  then
      validatevat strcountry
   end if
   if strhearaboutus=GetLang("langcommonselect") then
      strhearaboutus=""
   end if
   if GetConfig("xhearaboutusrequired")="Yes" and strhearaboutus="" then
      SError = SError & GetLang("langhearaboutus") & GetLang("langCustRequired") & "<br />"
   end if
end sub

sub CustomerValidateEmail (stremail)
   if not InStr(strEmail, "@") > 1 then
      SError=SError & GetLang("langInvalidEmail") & "<br />"
   end if
end sub

'Get values from shipping form
sub ShippingGetOtherFields
   dim words,wordcount,i, shippingfieldcount
   dim cfieldname, fieldvalue
   dim required, requiredcount, testfield, j
   if GetConfig("xshippingOtherFields")="" then exit sub
   redim words(GetConfig("xCustomerMaxotherfields"))
   redim Required(GetConfig("xcustomerMaxotherfields"))
   shippingFieldcount=GetSess("shippingFieldcount")
   ParseRecord GetConfig("xshippingOtherFields"), words, wordcount,","
   if GetConfig("xshippingOtherrequired")<>"" then
      ParseRecord GetConfig("xshippingOtherRequired"), required, requiredcount,","
   else
      requiredcount=0
   end if
   for i = 0 to wordcount-1
      cfieldname="s_" & words(i)

      'Security Patch - 17 April 2008
      fieldvalue=CleanChars(request(words(i)))

      if fieldvalue=GetLang("langcommonselect") then
         fieldvalue=""
      end if
      SetSess cfieldname, fieldvalue
   next
   SetSess "shippingFieldcount",wordcount
   if requiredcount=0 then exit sub

   for i = 0 to requiredcount-1
      testfield=ucase(required(i))
      cfieldname="s_" & testfield
      if GetSess(cfieldname)="" then 
         '6.50.4 Bugs Fix - 08 October 2008
         if lcase(required(i))=lcase(GetConfig("xshippingotherrequired")) then
            SError = SError & GetConfig("xshippingothercaptions") & " " & GetLang("langCustRequired") & "<br />"
	     else
            SError = SError & required(i) & " " & GetLang("langCustRequired") & "<br />"
   	     end if
      end if
   next
end sub

'see if customerid alread exists by userid
sub ValidateUsername (strcustuserid, SError, rc)
   dim sql, rs
   if SError<>"" then exit sub
   if GetConfig("xcustomeruserid")<>"Yes" then exit sub
   '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
   sql="select * from customers where userid="& sqlserverprefixn &"'" & replace(strcustuserid,"'","") & "'"
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open sql, dbc, adOpenDynamic, adLockOptimistic
   if not rs.eof then
      rc=4
      SError = SError & GetLang("langCustomerExists") & "<br />"
   end if
   CloseRecordSet rs
end sub

sub CustomerExcludetest (fieldname, excludefields, excludecount, rc)
   dim i, lfieldname
   lfieldname=lcase(fieldname)
   for i = 0 to excludecount-1
      if lfieldname=lcase(excludefields(i)) then
         rc=4
         exit sub
      end if
   next
   rc=0
end sub
%>