<%
'Front Page Side Box
sub Handle_leftsidebox (value)
   Value=""
   leftsidebox
end sub

sub Handle_rightsidebox (value)
   Value=""
   rightsidebox
end sub

sub rightsidebox
   loadsideboxcontent "rightsidebox"
end sub

'Front Page Side Box
sub leftsidebox
   loadsideboxcontent "leftsidebox"
end sub

'Loading SideBox Content
sub loadsideboxcontent (leftorright)
   dim tempstatus,strsql,sqlrs
   tempstatus = ""

   '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
   '700 - 2010.06.16 - Enhancement: Layout manager - multi-store support
   strsql="select * from containerbox where containerdivname = "& sqlserverprefixn &"'"& leftorright &"' and otheroptions1 = 'Yes' "
   GenLayoutMgrStorematchSQL "and", strsql
   strsql = strsql & "order by otheroptions2 asc,containername asc"

   Set sqlrs = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   sqlrs.open strsql, dbc, adOpenStatic, adLockReadOnly
   if sqlrs.eof then
      '700 - 2010.05.03 - Check all databasae must close after opened.
      closerecordset sqlrs
      exit sub
   else
      if trim(lcase(leftorright)) = "leftsidebox" then
         htmlwrite "<div class=""side-bar"">"
      else
         htmlwrite "<div class=""rightside-bar"">"
      end if
      while not sqlrs.eof
	     tempstatus = sqlrs("otheroptions1")
		 if lcase(tempstatus) = "yes" then
		    select case lcase(sqlrs("containername"))
			   case "minicart"
				  gensideminicart sqlrs
			   case "categories"
			      gensidecategories sqlrs
			   case "search"
			      gensidesearch sqlrs
			   case "language"
			      gensidelanguage sqlrs
			   case "currency"
			      gensidecurrency sqlrs
			   case "featuredpros"
			      gensidefeaturedpros sqlrs
			   case "topseller"
			      gensidetopseller sqlrs
			   case "page"
			      gensidepage sqlrs
			   case "news"
			      gensidenews sqlrs
			   case "blogs"
			      gensideblogs sqlrs
			   case "freetext"
			      gensidefreetext sqlrs
			   case "freeimage"
			      gensidefreeimage sqlrs
			   '700 - layout manager enhancement - 2010.03.01
			   case "freeflash"
			      gensidefreeflash sqlrs
			   '700 - layout manager enhancement - 2010.03.30
			   case "randomproducts"
			      gensiderandomproducts sqlrs
			   '700- 2010.04.05 - twitter
               case "twitter"
		          gensidetwitter sqlrs

			end select
		 end if
	     sqlrs.movenext
	  wend
      htmlwrite "<div style=""clear:both""></div>"
      htmlwrite "</div>"
   end if
   closerecordset sqlrs
end sub

sub gensidepage (sqlrs)
   if trim(sqlrs("id")) = "" then exit sub
   if isnumeric(sqlrs("id")) = false then exit sub

   dim howmanyitems
   dim category,categorys(9999),categorycnt,icnt
   if isnull(sqlrs("labelfield")) = false then
      if trim(sqlrs("labelfield")) <> "" then
 	     htmlwrite "<div class=""sidebarcell"">"
		 htmlwrite "<div id=""side_page_title_"& sqlrs("id") &""" class=""title"">"
	     htmlwrite "<h2>"& sqlrs("labelfield") &"</h2>"
		 htmlwrite"</div>"
		 htmlwrite "</div>"
	  end if
   end if

   category = sqlrs("otheroptions4")
   categorycnt = 0
   if isnull(category) = false then
      parserecord category,categorys,categorycnt,","
   end if
	  
   for icnt = 0 to (categorycnt - 1)
      htmlwrite "<div class=""sidebarcell"">"
	  htmlwrite "<div id=""side_page_title_"& icnt &"_"& sqlrs("id") &""" class=""title"">"
      htmlwrite "<h2>"
	  ShowContentBoxCatName categorys(icnt)
   	  htmlwrite "</h2>"
	  htmlwrite"</div>"
	  htmlwrite "<div class=""contentcell"">"
      if isnumeric(sqlrs("otheroptions3")) = false then
         howmanyitems = 10
      else
	     howmanyitems = int(sqlrs("otheroptions3"))
      end if
	  htmlwrite "<ul class=""sidepage"">"
  	  ShowContentBox categorys(icnt),howmanyitems
	  htmlwrite "</ul>"
	  htmlwrite "</div>"
	  htmlwrite "</div>"
   next
end sub

sub gensidetopseller (sqlrs)
   if trim(sqlrs("id")) = "" then exit sub
   if isnumeric(sqlrs("id")) = false then exit sub
   
   '700 - 2010.09.30 - Enhancement: Better handling if xlogonrequired is Yes
   if GetConfig("xlogonrequired")="Yes" and GetSess("Login")="" then exit sub

   htmlwrite "<div class=""sidebarcell"">"
   htmlwrite "<div id=""side_topseller_title_"& sqlrs("id") &""" class=""title"">"
   if isnull(sqlrs("labelfield")) = false then
      if trim(sqlrs("labelfield")) <> "" then
   	     htmlwrite "<h2>"& translatehpmgrcaptions(sqlrs("labelfield")) &"</h2>"
	  else
	     'htmlwrite "<h2>"& GetLang("langtopsellers") &"</h2>"
	  end if
   else
	  'htmlwrite "<h2>"& GetLang("langtopsellers") &"</h2>"
   end if
   htmlwrite "</div>"

   htmlwrite "<div class=""contentcell"">"
   htmlwrite "<div class=""sidetopseller"">"
	  
   dim howmanyitems
   if isnumeric(sqlrs("otheroptions3")) = false then
      howmanyitems = 10
   else
      howmanyitems = int(sqlrs("otheroptions3"))
   end if
	  
   dim processstatus
   if lcase(sqlrs("otheroptions4")) = "yes" then
      'to slide show
      '701 - 2011.04.19 - Enhancement: Speed enhancement fixes
      if session("showcontentslider") = "" then
	     session("showcontentslider") = "Yes"
%>
<link rel="stylesheet" type="text/css" media="all" href="stylesheets/contentslider.css" />
<script language="javascript" type="text/javascript" src="js/contentslider.js"></script>
<%
	  end if

	  htmlwrite "<div id=""slidertopseller-"& sqlrs("id") &""" class=""sliderwrapper"">"
      NavigateTopSeller howmanyitems
	  htmlwrite "</div>"
		 
	  processstatus = true
      if GetConfig("xlogonrequired") = "Yes" then
         if GetSess("Login") = "" then
	        processstatus = false
  	     end if
	  end if
		 
	  if getsess("homepagetsrecord") = "yes" and processstatus then
	     htmlwrite "<div id=""paginate-slidertopseller-"& sqlrs("id") &""" class=""pagination"">"
     	 htmlwrite "<a href=""#"" class=""next"">></a> <a href=""#"" class=""prev"" ><</a></div>"

		 '701 - 2011.01.10 - Better handling paging slider layout
		 htmlwrite "<div class=""cb""></div>"
%>
					<script type="text/javascript">
					featuredcontentslider.init({
						id: "slidertopseller-<%=sqlrs("id")%>",  //id of main slider DIV
						contentsource: ["inline", ""],  //Valid values: ["inline", ""] or ["ajax", "path_to_file"]
						toc: "markup",  //Valid values: "#increment", "markup", ["label1", "label2", etc]
						nextprev: ["",""],  //labels for "prev" and "next" links. Set to "" to hide.
						revealtype: "click", //Behavior of pagination links to reveal the slides: "click" or "mouseover"
						enablefade: [true, <%=getconfig("xSliderfadedegree")%>],  //[true/false, fadedegree]
						autorotate: [true, <%=getconfig("xSliderAutoRotatePauseTime")%>],  //[true/false, pausetime]
						onChange: function(previndex, curindex){  //event handler fired whenever script changes slide
							//previndex holds index of last slide viewed b4 current (1=1st slide, 2nd=2nd etc)
							//curindex holds index of currently shown slide (1=1st slide, 2nd=2nd etc)
						}
					})
					</script>
<%
      end if
   else
      NavigateTopSeller howmanyitems
   end if
	  
   htmlwrite "</div>"
   htmlwrite "</div>"
   htmlwrite "</div>"
end sub

sub gensidefeaturedpros (sqlrs)
   if trim(sqlrs("id")) = "" then exit sub
   if isnumeric(sqlrs("id")) = false then exit sub
   
   '700 - 2010.09.30 - Enhancement: Better handling if xlogonrequired is Yes
   if GetConfig("xlogonrequired")="Yes" and GetSess("Login")="" then exit sub

   dim processstatus
   htmlwrite "<div class=""sidebarcell"">"
   htmlwrite "<div id=""side_featuredproduct_title_"& sqlrs("id") &""" class=""title"">"
   if isnull(sqlrs("labelfield")) = false then
      if trim(sqlrs("labelfield")) <> "" then
         htmlwrite "<h2>"& translatehpmgrcaptions(sqlrs("labelfield")) &"</h2>"
	  end if
   end if
   htmlwrite "</div>"

   htmlwrite "<div class=""contentcell"">"
   htmlwrite "<div class=""sidefeaturedproducts"">"
		 
   if lcase(sqlrs("otheroptions3")) = "yes" then
      'to slide show
      '701 - 2011.04.19 - Enhancement: Speed enhancement fixes
      if session("showcontentslider") = "" then
	     session("showcontentslider") = "Yes"
%>
<link rel="stylesheet" type="text/css" media="all" href="stylesheets/contentslider.css" />
<script language="javascript" type="text/javascript" src="js/contentslider.js"></script>
<%
	  end if

	  '700 - layout manager enhancement - 2010.03.30
	  htmlwrite "<div id=""sliderfeaturedproduct-"& sqlrs("id") &""" class=""sliderwrapper"">"
	  NavigateFeaturedProductsNew sqlrs("otheroptions5"), sqlrs("otheroptions6")

	  htmlwrite "</div>"
		 
	  processstatus = true
      if GetConfig("xlogonrequired") = "Yes" then
         if GetSess("Login") = "" then
		    processstatus = false
  		 end if
      end if
		 
	  if getsess("homepagefprecord") = "yes" and processstatus then
   	     '700 - layout manager enhancement - 2010.03.30
	     htmlwrite "<div id=""paginate-sliderfeaturedproduct-"& sqlrs("id") &""" class=""pagination"">"
 	 	 htmlwrite "<a href=""#"" class=""next"">&gt;</a> <a href=""#"" class=""prev"" >&lt;</a></div>"
		 
		 '701 - 2011.01.10 - Better handling paging slider layout
		 htmlwrite "<div class=""cb""></div>"
%>
					<script type="text/javascript">
					featuredcontentslider.init({
						id: "sliderfeaturedproduct-<%=sqlrs("id")%>",  //id of main slider DIV
						contentsource: ["inline", ""],  //Valid values: ["inline", ""] or ["ajax", "path_to_file"]
						toc: "markup",  //Valid values: "#increment", "markup", ["label1", "label2", etc]
						nextprev: ["",""],  //labels for "prev" and "next" links. Set to "" to hide.
						revealtype: "click", //Behavior of pagination links to reveal the slides: "click" or "mouseover"
						enablefade: [true, <%=getconfig("xSliderfadedegree")%>],  //[true/false, fadedegree]
						autorotate: [true, <%=getconfig("xSliderAutoRotatePauseTime")%>],  //[true/false, pausetime]
						onChange: function(previndex, curindex){  //event handler fired whenever script changes slide
							//previndex holds index of last slide viewed b4 current (1=1st slide, 2nd=2nd etc)
							//curindex holds index of currently shown slide (1=1st slide, 2nd=2nd etc)
						}
					})
					</script>
<%
 	  end if
   else
	  ' normal display
	  '700 - layout manager enhancement - 2010.03.30
   	  NavigateFeaturedProductsNew sqlrs("otheroptions5"), sqlrs("otheroptions6")
   end if
   
   htmlwrite "</div>"
   htmlwrite "</div>"
   htmlwrite "</div>"
end sub

sub gensidecurrency (sqlrs)
   if trim(sqlrs("id")) = "" then exit sub
   if isnumeric(sqlrs("id")) = false then exit sub
   
   '700 - 2010.09.30 - Enhancement: Better handling if xlogonrequired is Yes
   if GetConfig("xlogonrequired")="Yes" and GetSess("Login")="" then exit sub

   htmlwrite "<div class=""sidebarcell"">"
   htmlwrite "<div id=""side_currency_title_"& sqlrs("id") &""" class=""title"">"
   if isnull(sqlrs("labelfield")) = false then
      if trim(sqlrs("labelfield")) <> "" then
	     htmlwrite "<h2>"& translatehpmgrcaptions(sqlrs("labelfield")) &"</h2>"
	  else
	     'htmlwrite "<h2>"& GetLang("langcurrency") &"</h2>"
	  end if
   else
	  'htmlwrite "<h2>"& GetLang("langcurrency") &"</h2>"
   end if
   htmlwrite "</div>"

   htmlwrite "<div class=""contentcell"">"
   htmlwrite "<div class=""sidecurrency"">"
   htmlwrite "<p><a href=""shopcurrency.asp"">"& GetLang("langchangecurrency") &"</a></p>"
   
   if isnull(sqlrs("otheroptions3")) = false then
      if lcase(sqlrs("otheroptions3")) = "yes" then
         htmlwrite "<p><a href=""shopcurrency.asp"">"
	     ShowCurrencyFlag
	     htmlwrite "</a></p>"
	  end if
   end if

   if isnull(sqlrs("otheroptions4")) = false then
      select case lcase(sqlrs("otheroptions4"))
         case "yes"
	        Navigateshowcurrencies "cur" & sqlrs("id")
         case "no"
            navigateshowcurrency
      end select
   end if
   htmlwrite "</div>"
   htmlwrite "</div>"
   htmlwrite "</div>"
end sub

sub gensidelanguage (sqlrs)
   if trim(sqlrs("id")) = "" then exit sub
   if isnumeric(sqlrs("id")) = false then exit sub

   htmlwrite "<div class=""sidebarcell"">"
   htmlwrite "<div id=""side_language_title_"& sqlrs("id") &""" class=""title"">"
   if isnull(sqlrs("labelfield")) = false then
      if trim(sqlrs("labelfield")) <> "" then
	     htmlwrite "<h2>"& translatehpmgrcaptions(sqlrs("labelfield")) &"</h2>"
      else
	     'htmlwrite "<h2>"& GetLang("langlanguage") &"</h2>"
	  end if
   else
	  'htmlwrite "<h2>"& GetLang("langlanguage") &"</h2>"
   end if
   htmlwrite "</div>"
		 
   htmlwrite "<div class=""contentcell"">"
   htmlwrite "<div class=""sidelanguage"">"
   Navigateshowlanguages "lang" & sqlrs("id")
   htmlwrite "</div>"
   htmlwrite "</div>"
   htmlwrite "</div>"
end sub

sub gensidesearch (sqlrs)
   if trim(sqlrs("id")) = "" then exit sub
   if isnumeric(sqlrs("id")) = false then exit sub
   
   '700 - 2010.09.30 - Enhancement: Better handling if xlogonrequired is Yes
   if GetConfig("xlogonrequired")="Yes" and GetSess("Login")="" then exit sub

   dim prefix
   
   prefix = "left" & sqlrs("id")
   htmlwrite "<div class=""sidebarcell"">"
   htmlwrite "<div id=""side_search_title_"& sqlrs("id") &""" class=""title"">"
   if isnull(sqlrs("labelfield")) = false then
      if trim(sqlrs("labelfield")) <> "" then
	     htmlwrite "<h2>"& translatehpmgrcaptions(sqlrs("labelfield")) &"</h2>"
	  else
		 'htmlwrite "<h2>"& GetLang("langhpmgrsearch") &"</h2>"
	  end if
   else
	  'htmlwrite "<h2>"& GetLang("langhpmgrsearch") &"</h2>"
   end if
   htmlwrite "</div>"
		 
   htmlwrite "<div class=""contentcell"">"
   htmlwrite "<div class=""sidesearch"">"
   navigateshowsearch prefix, "", sqlrs("otheroptions3")
   htmlwrite "</div>"
   htmlwrite "</div>"
   htmlwrite "</div>"
end sub

'700 - 2010.05.31 - Enhancement: Category Flyout issue with browser IE6 and W3C
dim flyout1counter
flyout1counter = 0
sub gensidecategories (sqlrs)
   if trim(sqlrs("id")) = "" then exit sub
   if isnumeric(sqlrs("id")) = false then exit sub
   
   '700 - 2010.09.30 - Enhancement: Better handling if xlogonrequired is Yes
   if GetConfig("xlogonrequired")="Yes" and GetSess("Login")="" then exit sub

   htmlwrite "<div class=""sidebarcell"">"
   htmlwrite "<div id=""side_categories_title_"& sqlrs("id") &""" class=""title"">"
   if isnull(sqlrs("labelfield")) = false then
      if trim(sqlrs("labelfield")) <> "" then
	     htmlwrite "<h2>"& translatehpmgrcaptions(sqlrs("labelfield")) &"</h2>"
	  end if
   end if
   htmlwrite "</div>"

   '700 - 2010.05.19 - Bug Fix: Category Flyout issue with browser IE6
   htmlwrite "<div class=""contentcell"">"
   if lcase(sqlrs("otheroptions3")) = "flyout" then
      'htmlwrite "<div id=""catnavflyout"">"
	  '700 - 2010.05.31 - Enhancement: Category Flyout issue with browser IE6 and W3C
	  flyout1counter = flyout1counter + 1
	  htmlwrite "<div class=""flyout"">"
   end if
   
   if isnull(sqlrs("otheroptions3")) = false then
      select case lcase(sqlrs("otheroptions3"))
         case "dropdown"
	        NavigateShowCategoriesStyled "dropdown",sqlrs("containerdivname")
         case "flyout"
		    NavigateShowCategoriesStyled "flyout",sqlrs("containerdivname")
   	     case else
   	        NavigateShowCategories
      end select
   else
      NavigateShowCategories
   end if
   htmlwrite "</div>"

   '700 - 2010.05.19 - Bug Fix: Category Flyout issue with browser IE6
   if lcase(sqlrs("otheroptions3")) = "flyout" then
      htmlwrite "</div>"
   end if
   
   htmlwrite "</div>"
end sub

'Front Page - Side Box - Mini Cart
sub gensideminicart (sqlrs)
   if trim(sqlrs("id")) = "" then exit sub
   if isnumeric(sqlrs("id")) = false then exit sub
   
   '700 - 2010.09.30 - Enhancement: Better handling if xlogonrequired is Yes
   if GetConfig("xlogonrequired")="Yes" and GetSess("Login")="" then exit sub

   htmlwrite "<div class=""sidebarcell"">"
   htmlwrite "<div id=""side_minicart_title_"& sqlrs("id") &""" class=""title"">"
   if isnull(sqlrs("labelfield")) = false then
      if trim(sqlrs("labelfield")) <> "" then
	     htmlwrite "<h2>"& translatehpmgrcaptions(sqlrs("labelfield")) &"</h2>"
	  end if
   end if
   htmlwrite "</div>"
   NavigateShowMiniCartCssStyled
   htmlwrite "</div>"
end sub
%>