<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Points subroutines
'*********************************************************************************

sub Generatepoints (dbc, orderid)
   dim customerid, pointstotal, rc, orderrs, msg, rcpoints
   if GetConfig("xpoints")<>"Yes" then exit sub
   CheckusingPoints rcpoints
   if rcpoints = 0 then
      pointstotal = 0
      GetProductpoints dbc, orderid, pointstotal, customerid
      if pointstotal>0 then
         InternalOpenOrder dbc, OrderRs, orderid
         ValidatePurchase OrderRS, rc
         CloseRecordSet orderRS
         if rc = 0 then
            Addcustomerpoints customerid, pointstotal
            msg = ""
         else
            msg = GetLang("langpointsremaining") & " " & pointstotal
         end if
         AddOrderPoints dbc, orderid, pointstotal, msg
      end if
   end if
end sub

sub PointsDecrementCustomer (dbc, orderid)
   dim customerid, pointstotal
   pointstotal = 0
   GetProductpoints dbc, orderid, pointstotal, customerid
   if pointstotal>0 then
      Decrementcustomerpoints customerid, pointstotal
   end if
end sub

' Get product points
sub GetProductPoints( dbc, orderid, pointstotal, customerid)
   dim rc, amount, coupondiscount, numItems
   dim ProductRS
   dim strSQL
   dim orderRS
   dim productCatalogId, prodpoints, prodquantity, prodpointsredeem
   dim prodprice
   dim sql
   pointstotal = 0
   sql = "select * from orders where orderid=" & orderid
   Set rsorder = Server.CreateObject("ADODB.Recordset")
   rsorder.open SQL, dbc, adOpenDynamic, adLockOptimistic
   customerid = rsorder("ocustomerid")
   '6.00 - needs to take into account coupon discount when calculating points
   coupondiscount = rsorder("coupondiscount")

   '6.00 - needs to take into account coupon discount when calculating points
   if coupondiscount > 0 then
      strSQL = "select count(*) as numitems from oitems where orderid = " & orderid
      Set ProductRS = Server.CreateObject("ADODB.Recordset")
      ProductRS.open strSQL, dbc, adOpenDynamic, adLockOptimistic
      numItems = productrs("numitems")
      CloseRecordSet productrs

      coupondiscount = cint(coupondiscount) / cint(numItems)
   end if

   strSQL = "select * FROM oitems where orderid = " & orderid
   Set ProductRS = Server.CreateObject("ADODB.Recordset")
   ProductRS.open strSQL, dbc, adOpenDynamic, adLockOptimistic
   do while not ProductRS.eof
      ProductCatalogId = productrs("CatalogId")
      prodquantity = productrs("numitems")
      prodprice = productrs("unitprice")
      '6.00 - needs to take into account coupon discount when calculating points
      if coupondiscount > 0 then
         prodprice = prodprice - coupondiscount
      end if

      if GetConfig("xpointsequalcurrency") = "Yes" then
         prodpoints = prodprice
      else
         Getpoints dbc, ProductCatalogId, prodpoints, prodpointsredeem
      end if
      if GetConfig("xdebug") = "Yes" then
         DebugWrite "CatalogId=" & productCatalogId & " points=" & prodpoints
      end if
      prodpoints = prodpoints * prodquantity
      pointstotal = pointstotal + prodpoints
      ProductRS.MoveNext
   loop
   CloseRecordSet productrs
   CloseRecordSet rsorder
   if GetConfig("xpointsequalcurrency") = "Yes" then
      '700 - 2010.08.03 - Enhancement: Better condition for pointtotal at shoppointsdb.asp
      if isnumeric(pointstotal) then pointstotal = round(pointstotal, 0)
   end if
end sub

' Get points for one product
sub Getpoints (dbc, ProductCatalogId, prodpoints, prodpointstobuy)
   prodpoints = 0
   prodpointstobuy = 0
   dim psql, rs, pointsfield
   pointsfield = "points"
   psql = "select * from products where CatalogId=" & productCatalogId
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open psql, dbc, adOpenDynamic, adLockOptimistic
   if not rs.eof then
      prodpoints = rs(pointsfield)
      if isnull(prodpoints) then
         prodpoints = 0
      end if
      prodpointstobuy = rs("pointstobuy")
      if isnull(prodpointstobuy) then
         prodpointstobuy = 0
      end if
   end if
   CloseRecordSet rs
   if not isnumeric(prodpoints) then
      prodpoints = 0
   end if
   prodpoints = clng(prodpoints)
end sub

' add points to customer record
sub AddCustomerPoints (customerid, pointstotal)
   dim sql, pointsremaining, custpointstotal, rs
   Sql = "select * from customers where contactid=" & customerid
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open sql, dbc, adOpenDynamic, adLockOptimistic
   if rs.eof then
      CloseRecordSet rs
      exit sub
   end if
   pointsremaining = rs("pointsremaining")
   custpointstotal = rs("pointstotal")
   if isnull(pointsremaining) then
      pointsremaining = 0
   end if
   if isnull(custpointstotal) then
      custpointstotal = 0
   end if
   CloseRecordSet rs
   custpointstotal = custpointstotal + pointstotal
   pointsremaining = pointsremaining + pointstotal
   sql = "update customers set pointstotal=" & custpointstotal
   sql = sql & ",pointsremaining=" & pointsremaining
   sql = sql & " where contactid=" & customerid
   dbc.execute(sql)
end sub

' remove points from customer record
sub DecrementCustomerPoints (customerid, pointstotal)
   dim sql, pointsremaining, rs
   Sql = "select * from customers where contactid=" & customerid
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open sql, dbc, adOpenDynamic, adLockOptimistic
   if rs.eof then
      CloseRecordSet rs
      exit sub
   end if
   pointsremaining = rs("pointsremaining")
   if isnull(pointsremaining) then
      pointsremaining = 0
   end if
   CloseRecordSet rs
   pointsremaining = pointsremaining - pointstotal
   sql = "update customers set pointsremaining=" & pointsremaining
   sql = sql & " where contactid=" & customerid
   dbc.execute(sql)
end sub

' Get number of points for a customer
sub GetCustomerpoints (customerid, pointstotal, pointsremaining)
   dim sql, rs
   pointstotal = 0
   pointsremaining = 0
   Sql = "select * from customers where contactid=" & customerid
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open sql, dbc, adOpenDynamic, adLockOptimistic
   if rs.eof then
      CloseRecordSet rs
      exit sub
   end if
   pointstotal = rs("pointstotal")
   pointsremaining = rs("pointsremaining")
   if isnull(pointstotal) then
      pointstotal = 0
      pointsremaining = 0
   end if
   CloseRecordSet rs
end sub

' Display customer points
sub PointsDisplay (customerid)
   if GetConfig("xpoints")<>"Yes" then exit sub
   dim pointstotal, pointsremaining
   GetCustomerpoints customerid, pointstotal, pointsremaining
   response.write ReportTableDef
   response.write ReportHeadRow
   response.write ReportHeadColumn & GetLang("LangPointsTotal") & ReportHeadColumnEnd
   response.write ReportHeadColumn & GetLang("LangPointsRemaining") & ReportHeadColumnEnd
   response.write ReportRowEnd
   response.write ReportDetailRow
   response.write ReportDetailColumn & "<p class=""ar"">" & pointstotal & "</p>" & ReportDetailcolumnEnd
   response.write ReportDetailColumn & "<p class=""ar"">" & pointsremaining & "</p>" & ReportDetailcolumnEnd
   response.write "</tr>"
   response.write "</table>"
end sub

sub AddOrderPoints (dbc, orderid, pointstotal, msg)
   dim sql
   sql = "update orders set opoints=" & pointstotal
   if msg<>"" then
      '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
      sql = sql & ",other1="& sqlserverprefixn &"'" & msg & "'"
   end if
   sql = sql & " where orderid=" & orderid
   dbc.execute(sql)
end sub

' See if customer can order from points
sub PointsVerifyOrder
   dim cartcount, prodpoints, prodpointstobuy, pointsremaining
   dim ArrCart, prodid, i
   if GetConfig("xpointsredeem") = "No" then exit sub
   if GetSess("PointsOrder")<>"Yes" then exit sub
   if GetSess("pointsremaining") = "" then exit sub
   pointsremaining = GetSess("pointsremaining")
   pointsremaining = clng(pointsremaining)
   cartcount = GetSess("CartCount")
   if cartcount> 1 then
      ShopError "Points can be redeemed for only one product at a time"
   end if
   ArrCart = GetSessA("CartArray")
   ' go through all products
   i = 1
   prodid = ArrCart(cProductid, i)
   Getpoints dbc, Prodid, prodpoints, prodpointstobuy
   if prodpointstobuy = 0 then
      ShopError "Product cannot be bought with points"
   end if
   if pointsremaining<prodpointstobuy then
      ShopError "Product requires " & prodpointstobuy & " and you have " & pointsremaining
   end if
end sub

sub HandlePointsOrder
   dim cartcount, prodpoints, prodpointsredeem
   dim orderid, ArrCart, ordertotal
   dim prodprice, prodquantity, pointsremaining, i, strsql
   if GetConfig("xpointsredeem") = "No" then exit sub
   if GetSess("PointsOrder")<>"Yes" then exit sub
   if GetSess("pointsremaining") = "" then exit sub
   pointsremaining = GetSess("pointsremaining")
   pointsremaining = clng(pointsremaining)

   orderid = GetSess("Oid")
   PointsDecrementCustomer dbc, orderid
   i = 1
   ArrCart = GetSessA("CartArray")
   ProdPrice = ArrCart(cUnitPrice, i)
   Prodquantity = ArrCart(cQuantity, i)
   Prodprice = Prodprice * Prodquantity
   ordertotal = GetSess("ordertotal")
   ordertotal = ordertotal - prodprice
   if ordertotal<0 then
      ordertotal = 0
   end if
   SetSess "ordertotal", ordertotal
   Strsql = "Update orders set orderamount=" & ordertotal
   '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
   strsql = strsql & ",giftcertificate="& sqlserverprefixn &"'" & GetLang("Langpoints") &"'" & " where orderid=" & GetSess("oid")
   DebugWrite strsql
   dbc.execute(Strsql)
end sub

'if points are used for gift certificate or coupon.
'dont give points
sub Checkusingpoints (rc)
   rc = 0
   dim coupon, gift, pos
   dim langpoints
   langpoints = trim(GetLang("langpoints"))
   langpoints = lcase(langpoints)
   coupon = GetSess("coupon")
   if coupon<>"" then
      pos = instr(lcase(coupon), langpoints)
      if pos>0 then
         rc = 4
         exit sub
      end if
   end if
   gift = GetSess("Giftcertificate")
   if gift = "" then exit sub
   pos = instr(lcase(gift), langpoints)
   if pos>0 then
      rc = 4
      exit sub
   end if
end sub
%>