<%
'*********************************************************************************
' 7.00
' 2 Apr 2010
' AddThis at shopexd.asp shopdisplayproducts.asp routines
'*********************************************************************************

' Hanlde AddThis routine
sub Handle_AddThis (ivalue,parsearray,parseRS)
   dim XAddThisUserName
   XAddThisUserName = getconfig("XAddThisUserName")
   if getconfig("xAddThisEnable") <> "Yes" then exit sub
   if trim(XAddThisUserName) = ""  then exit sub
   
   '700 - 2010.07.07 - Enhancement: Deal addthis & polyvore via SSL
   '7.01 - 2010.10.07 - ug Fix: Some server not supporting https
   '701 - 2010.11.30 - Enhancement: Support HTTP_CLUSTER_HTTPS for secured mode
   if lcase(request.ServerVariables("HTTPS")) = "on" or lcase(request.ServerVariables("HTTP_X_HTTPS")) = "on" or lcase(request.ServerVariables("HTTP_CLUSTER_HTTPS")) = "on" then
%>
<!-- AddThis Button BEGIN -->
<a class="addthis_button" href="https://www.addthis.com/bookmark.php?v=250&amp;username=<%=XAddThisUserName%>">
<img class="img_addthis" src="https://s7.addthis.com/static/btn/v2/lg-share-en.gif" />
</a>
<script type="text/javascript" src="https://s7.addthis.com/js/250/addthis_widget.js#username=<%=XAddThisUserName%>"></script>
<!-- AddThis Button END -->
<%
   else
%>
<!-- AddThis Button BEGIN -->
<a class="addthis_button" href="http://www.addthis.com/bookmark.php?v=250&amp;username=<%=XAddThisUserName%>">
<img class="img_addthis" src="http://s7.addthis.com/static/btn/v2/lg-share-en.gif" />
</a>
<script type="text/javascript" src="http://s7.addthis.com/js/250/addthis_widget.js#username=<%=XAddThisUserName%>"></script>
<!-- AddThis Button END -->
<%
   end if
end sub

' Handle Polyvore routine
sub Handle_Polyvore (ivalue,parsearray,parseRS)
   if getconfig("xAddThisPolyvoreEnable") <> "Yes" then exit sub
   dim polyvoreurlstring
   polyvoreurlstring = "shopexd.asp?id="& parseRS("catalogid") &""
   genseoproductlink polyvoreurlstring,parseRS("catalogid"),parseRS(getconfig("xSEODynamicProductsField")),"No"
   polyvoreurlstring = genredirecturl(polyvoreurlstring)
   
   '700 - 2010.07.07 - Enhancement: Deal addthis & polyvore via SSL
   '7.01 - 2010.10.07 - ug Fix: Some server not supporting https
   '701 - 2010.11.30 - Enhancement: Support HTTP_CLUSTER_HTTPS for secured mode
   if lcase(request.ServerVariables("HTTPS")) = "on" or lcase(request.ServerVariables("HTTP_X_HTTPS")) = "on" or lcase(request.ServerVariables("HTTP_CLUSTER_HTTPS")) = "on" then
   else
      '701 - 2010.10.22 - Bug Fix: Polyvore should open in a new windows
	  '701 - 2011.06.09 - Bug Fix: Quote not displaying properly with Addthis Polyvore link
%>
<!-- Polyvore Button BEGIN -->
<a href="http://www.polyvore.com/cgi/add?title=<%=server.HTMLEncode(parseRS("cname"))%>&url=<%=polyvoreurlstring%>&imgurl=<%=xmysite2 & "/" & parseRS("extendedimage")%>" target="_blank">
<img class="img_polyvore" src="http://cdn.polyvore.com/rsrc/img/favicon.png" />
</a>
<!-- Polyvore Button END -->
<%
   end if
end sub
%>